/**
 * Copyright (C) 2010 Cloudfarming <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package nl.cloudfarming.client.messaging.inbox;

import java.awt.Point;
import javax.swing.JTextArea;
import javax.swing.ScrollPaneConstants;
import javax.swing.ScrollPaneLayout;

/**
 * JtextArea which displays the details of the selected message.
 * @author Merijn Zengers
 */
public class MessageDetailPanel extends javax.swing.JScrollPane {
        private final JTextArea messageTextContent;
    
       
    public MessageDetailPanel() {
        messageTextContent = new JTextArea();
        this.setLayout(new ScrollPaneLayout());
        this.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        this.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
    
        messageTextContent.setEditable(false);
        messageTextContent.setLineWrap(true);
        messageTextContent.setWrapStyleWord(true);
        
        this.setViewportView(messageTextContent);
    }

    /**
     * Sets the text on the area
     * @param text the text to set
     */
    public void setMessageText(String text){
        messageTextContent.setText(text);
        // Start scrollbar on top
        messageTextContent.setCaretPosition(0);
    }
    
    public String getMessageText(){
        return messageTextContent.getText();
    }
    
}
